﻿using AdventOfCode2023.Day5;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace AdventOfCode2023.Day6
{
    public class Day6_1 : DayBase
    {
        string input = string.Empty;

        Regex rxTime = new Regex(@"(?<=Time:[\s\d]+)\d+");
        Regex rxDistance = new Regex(@"(?<=Distance:[\s\d]+)\d+");

        public Day6_1()
        {
            input = GetInput("Day6.txt");
        }

        public Day6_1(string testInput)
        {
            input = testInput;
        }

        public override string Execute()
        {
            ulong winningMovesProduct = 0;

            var times = rxTime.Matches(input).Select(x => int.Parse(x.Value)).ToArray();
            var distances = rxDistance.Matches(input).Select(x => int.Parse(x.Value)).ToArray();

            List<Race> races = new List<Race>();
            for (int i = 0; i < times.Count(); i++)
            {
                races.Add(new Race(times[i], distances[i]));
            }

            foreach (var race in races)
            {
                var winningMoves = Enumerable.Range(0, race.Time).Count(x => x * (race.Time - x) > race.Distance);
                winningMovesProduct = winningMovesProduct == 0 ? (ulong)winningMoves : (ulong)winningMoves * winningMovesProduct;
            }

            return winningMovesProduct.ToString();
        }
    }

    internal class Race
    {
        public int Distance { get; }
        public int Time { get; }

        public Race(int time, int distance)
        {
            Time = time;
            Distance = distance;
        }
    }
}
